import global from 'whenthough';
const COMPONENT_CACHE = new Map();
const DEFAULT_SHADOWMODE = { mode: 'open' };
const COMPONENTS = global.set(Symbol.for('@wayang/web-components'), new Map());
const PRESENTERS = global.set(Symbol.for('@wayang/presenters'), new Map());
const MIXINS = global.set(Symbol.for('@wayang/mixins'), new Map());
const CONVERTERS = new Map([
    ['string', (value) => { return value; }],
    ['integer', (value) => { return parseInt(value); }],
    ['float', (value) => { return parseFloat(value); }],
    ['number', (value) => { return Number(value); }],
    ['json', (value) => { return JSON.parse(value); }],
    ['boolean', (value) => { value.toLowerCase() === 'true'; }],
    ['date', (value) => { return new Date(value); }],
    ['ticks', (value) => { return new Date(Number(value)); }],
    ['exists', (value) => { return (value !== null); }],
]);
const NO_TAG = '!no-tag';
const NO_HTML = '!no-html';
const NO_CSS = '!no-css';
export { COMPONENT_CACHE };
export { COMPONENTS };
export { PRESENTERS };
export { MIXINS };
export { CONVERTERS };
export { DEFAULT_SHADOWMODE };
export { NO_TAG };
export { NO_HTML };
export { NO_CSS };
