import WebComponent from './WebComponent';
declare abstract class Mixin {
    static id: string;
    static connect(component: WebComponent): void;
    static disconnect(component: WebComponent): void;
    static html(html: HTMLTemplateElement): void;
    static css(css: HTMLTemplateElement): void;
    static properties(properties: Map<string, string>): void;
    static observed(observed: string[]): void;
    static converters(converters: Map<string, (value: string) => any>): void;
    static register(): void;
    static stateOf(component: WebComponent): Map<string, any>;
    static attach(component: typeof WebComponent): void;
}
export default Mixin;
