import CacheItem from './CacheItem';
import Plugin from './Mixin';
declare abstract class UI extends HTMLElement {
    readonly root: ShadowRoot;
    readonly class: typeof UI;
    readonly global: any;
    constructor();
    static tag: string;
    static html: string;
    static css: string | string[];
    static observed: Map<string, string>;
    static converters: Map<string, (value: string) => any>;
    static mode: ShadowRootInit;
    static mixins: (typeof Plugin)[];
    static readonly observedAttributes: string[];
    connectedCallback(): void;
    adoptedCallback(): void;
    disconnectedCallback(): void;
    attributeChangedCallback(name: string, oldValue: string, newValue: string): void;
    presenter: string;
    dispatch<T>(eventName: string, data: T): boolean;
    listen(eventName: string, listener: EventListenerOrEventListenerObject): this;
    unlisten(eventName: string, listener: EventListenerOrEventListenerObject): this;
    select(selector: string): Element[];
    part(partName: string): Element | null;
    static readonly cache: CacheItem;
    static register(): void;
    destructor(): void;
}
export default UI;
