import { DEFAULT_SHADOWMODE } from '../Constants';
function validate(element) {
    if (element.tag == '!no-tag') {
        throw new Error('static tag: string, must be redefined.\n\
			String must be a valid custom element tag.');
    }
    if (!element.hasOwnProperty('html')) {
        throw new Error('static html: string, must be redefined.');
    }
    if (!element.hasOwnProperty('css')) {
        throw new Error('static css: string, must be redefined.');
    }
    if (!element.hasOwnProperty('mode')) {
        Object.defineProperty(element, 'mode', {
            value: DEFAULT_SHADOWMODE,
            writable: true
        });
    }
}
export default validate;
