import CacheItem from './CacheItem';
import Mixin from './Mixin';
declare abstract class WebComponent extends HTMLElement {
    readonly root: ShadowRoot;
    readonly class: typeof WebComponent;
    readonly global: any;
    private debouncers;
    constructor();
    static tag: string;
    static html: string;
    static css: string | string[];
    static observed: Map<string, string>;
    static converters: Map<string, (value: string) => any>;
    static mode: ShadowRootInit;
    static mixins: (typeof Mixin)[];
    static readonly observedAttributes: string[];
    connectedCallback(): void;
    adoptedCallback(): void;
    disconnectedCallback(): void;
    attributeChangedCallback(name: string, previous: string, current: string): void;
    presenter: string;
    dispatch<T>(eventName: string, data: T): boolean;
    listen(eventName: string, listener: EventListenerOrEventListenerObject): this;
    unlisten(eventName: string, listener: EventListenerOrEventListenerObject): this;
    select(selector: string): Element[];
    static readonly cache: CacheItem;
    static register(): void;
    destructor(): void;
}
export default WebComponent;
